#!/usr/bin/env python

import os
import term

esc = term.esc
ctl = lambda s: chr( 1 + ord(s) - ord('a') )

def init():
	term.stty('echo', False)
	term.stty('icanon', False)
	term.cursor_show(False)

def fini():
	term.cursor_show(True)
	term.stty('icanon', True)
	term.stty('echo', True)

def get():
	s = os.read( term.tty_r.fileno(), 10 )
	if type(s) != str:
		s =''.join( map(chr, s) )
	return s

def allow(k):
	tbls = [[
		[ 'u', 'd', 'l', 'r' ],
		[ esc('A'), esc('B'), esc('D'), esc('C') ], # allow
		[ ctl('p'), ctl('n'), ctl('b'), ctl('f') ], # emacs
		[ 'k', 'j', 'h', 'l' ], # vi
	],[
		[ 'pu', 'pd', 'pl', 'pr' ],
		[ esc('5~'), esc('6~'), esc('8~'), esc('7~') ], # allow
		[ chr(0xf6), ctl('v'), ctl('a'), ctl('e') ], # emacs
		[ 'b', 'f', '^', '$' ], # less, vi
	]]
	for tbl in tbls:
		for lst in tbl[1:]:
			if k in lst:
				return tbl[0][ lst.index(k) ]
	return ''

def dxy(k, def_val=None):
	d = allow(k)
	dic = { 'l': (-1,0), 'r': (1,0), 'u': (0,-1), 'd': (0,1) }
	return dic.get(d, def_val)

is_ok = lambda k: k in ('\n', ' ')
is_cancel = lambda k: k in ( chr(0x1b) )
is_allow = lambda k: allow(k) != ''

# EOF
